<template>
    <div
        class="row"
        :class="[isSender ? 'justify-end sender' : ' justify-start']"
    >
        <div
            class="content bubble-audio row"
            :class="[isSender ? 'justify-end' : '']"
        >
            <!-- Play Button -->
            <q-icon
                class="btn-action col text-center"
                :name="
                    audioPlayer?.waveSurfer.isPlaying() ? 'pause' : 'play_arrow'
                "
                size="30px"
                @click.stop="audioPlayer?.waveSurfer.playPause()"
            />

            <!-- Wave -->
            <div class="content-audio q-ml-sm col-6">
                <wavesurfer
                    ref="audioPlayer"
                    :src="message.file?.url"
                    :options="audioOptions"
                ></wavesurfer>
            </div>

            <!-- Duration -->
            <div
                v-if="audioPlayer?.waveSurfer.isPlaying()"
                class="col text-center duration"
            >
                {{ audioCurrentTime }}
            </div>

            <div v-else class="col text-center duration">
                {{
                    audioPlayer
                        ? secondToTime(audioPlayer?.waveSurfer.getDuration())
                        : ''
                }}
            </div>

            <!-- Time -->
            <span
                class="time-text helvetica-neue-medium font-10 q-pr-xs col-12"
            >
                {{ time }}
            </span>
            <q-btn
                dense
                text
                flat
                v-if="statusIcon.name"
                @click="resendErrorMessage(statusIcon.name, message.id)"
            >
                <q-icon
                    :name="statusIcon.name"
                    :color="statusIcon.color"
                    size="15px"
                />
            </q-btn>
        </div>
    </div>
</template>

<script lang="ts">
import { floor } from 'lodash';
import MessageController from '../../controller/MessageController';
import { defineComponent, ref, onMounted } from 'vue';
import { Message } from 'src/services/models/Message';
import { useStore } from 'src/store';

export default defineComponent({
    name: 'BubbleAudio',
    props: {
        message: {
            type: Object as () => Message,
            required: true
        }
    },
    setup(props) {
        const store = useStore();
        const { isSender, time, statusIcon } = MessageController(props.message);

        const audioPlayer = ref<any>(null);
        const audioOptions = {
            cursorWidth: 0,
            height: 40,
            waveColor:
                isSender.value || store.state.user.isDarkMode ? '#fff' : '#000',
            progressColor: '#b54242'
        };
        const secondToTime = (seconds: number) => {
            const minutes = seconds > 60 ? floor(seconds / 60) : 0;
            const remainderSeconds = floor(seconds % 60);
            return `${minutes}:${remainderSeconds.toString().padStart(2, '0')}`;
        };
        const audioCurrentTime = ref('0:00');

        const resendErrorMessage = (statusName: any, id: string) => {
            if (statusName == 'error') {
                store.dispatch('message/resendErrorMessage', id);
            }
        };

        onMounted(() => {
            if (audioPlayer.value?.waveSurfer) {
                audioPlayer.value?.waveSurfer.on('audioprocess', () => {
                    audioCurrentTime.value = secondToTime(
                        audioPlayer.value?.waveSurfer.getCurrentTime()
                    );
                });
            }
        });

        return {
            audioPlayer,
            audioOptions,
            secondToTime,
            audioCurrentTime,
            isSender,
            time,
            statusIcon,
            resendErrorMessage
        };
    }
});
</script>
